import { Location, GraphQLOutputType, GraphQLNamedType, Token, Source } from 'graphql';
import type { Comment } from 'estree';
import type { AST } from 'eslint';
export declare const valueFromNode: (valueNode: import("graphql").ValueNode, variables?: import("graphql/jsutils/ObjMap").ObjMap<unknown>) => any;
export declare function getBaseType(type: GraphQLOutputType): GraphQLNamedType;
declare type TokenKindValue = '<SOF>' | '!' | '$' | '&' | '(' | ')' | '...' | ':' | '=' | '@' | '[' | ']' | '{' | '|' | '}' | 'Name' | 'Int' | 'Float' | 'String' | 'BlockString' | 'Comment';
export declare function convertToken<T extends 'Line' | 'Block' | TokenKindValue>(token: Token, type: T): Omit<AST.Token, 'type'> & {
    type: T;
};
export declare function extractTokens(source: Source): AST.Token[];
export declare function extractCommentsFromAst(loc: Location): Comment[];
export {};
