export declare const rules: {
    alphabetize: import("..").GraphQLESLintRule<[import("./alphabetize").AlphabetizeConfig], false>;
    'description-style': import("..").GraphQLESLintRule<[{
        style: "block" | "inline";
    }], false>;
    'input-name': import("..").GraphQLESLintRule<[{
        checkInputType?: boolean;
        caseSensitiveInputType?: boolean;
        checkQueries?: boolean;
        checkMutations?: boolean;
    }], false>;
    'match-document-filename': import("..").GraphQLESLintRule<[import("./match-document-filename").MatchDocumentFilenameRuleConfig], false>;
    'naming-convention': import("..").GraphQLESLintRule<[import("./naming-convention").NamingConventionRuleConfig], false>;
    'no-anonymous-operations': import("..").GraphQLESLintRule<any[], false>;
    'no-case-insensitive-enum-values-duplicates': import("..").GraphQLESLintRule<any[], false>;
    'no-deprecated': import("..").GraphQLESLintRule<[], true>;
    'no-duplicate-fields': import("..").GraphQLESLintRule<any[], false>;
    'no-hashtag-description': import("..").GraphQLESLintRule<any[], false>;
    'no-root-type': import("..").GraphQLESLintRule<[{
        disallow: ("mutation" | "subscription")[];
    }], false>;
    'no-scalar-result-type-on-mutation': import("..").GraphQLESLintRule<any[], false>;
    'no-typename-prefix': import("..").GraphQLESLintRule<any[], false>;
    'no-unreachable-types': import("..").GraphQLESLintRule<any[], false>;
    'no-unused-fields': import("..").GraphQLESLintRule<any[], false>;
    'require-deprecation-date': import("..").GraphQLESLintRule<[{
        argumentName?: string;
    }], false>;
    'require-deprecation-reason': import("..").GraphQLESLintRule<any[], false>;
    'require-description': import("..").GraphQLESLintRule<[import("./require-description").RequireDescriptionRuleConfig], false>;
    'require-field-of-type-query-in-mutation-result': import("..").GraphQLESLintRule<any[], false>;
    'require-id-when-available': import("..").GraphQLESLintRule<[import("./require-id-when-available").RequireIdWhenAvailableRuleConfig], true>;
    'selection-set-depth': import("..").GraphQLESLintRule<[import("./selection-set-depth").SelectionSetDepthRuleConfig], false>;
    'strict-id-in-types': import("..").GraphQLESLintRule<[import("./strict-id-in-types").StrictIdInTypesRuleConfig], false>;
    'unique-fragment-name': import("..").GraphQLESLintRule<any[], false>;
    'unique-operation-name': import("..").GraphQLESLintRule<any[], false>;
};
