import { CaseStyle as _CaseStyle } from '../utils';
import { GraphQLESLintRule } from '../types';
declare type CaseStyle = _CaseStyle | 'matchDocumentStyle';
declare const ACCEPTED_EXTENSIONS: ['.gql', '.graphql'];
declare type PropertySchema = {
    style?: CaseStyle;
    suffix?: string;
};
export declare type MatchDocumentFilenameRuleConfig = {
    fileExtension?: typeof ACCEPTED_EXTENSIONS[number];
    query?: CaseStyle | PropertySchema;
    mutation?: CaseStyle | PropertySchema;
    subscription?: CaseStyle | PropertySchema;
    fragment?: CaseStyle | PropertySchema;
};
declare const rule: GraphQLESLintRule<[MatchDocumentFilenameRuleConfig]>;
export default rule;
