import { Kind } from 'graphql';
import { GraphQLESLintRule } from '../types';
declare const ALLOWED_KINDS: readonly [Kind.OBJECT_TYPE_DEFINITION, Kind.INTERFACE_TYPE_DEFINITION, Kind.ENUM_TYPE_DEFINITION, Kind.SCALAR_TYPE_DEFINITION, Kind.INPUT_OBJECT_TYPE_DEFINITION, Kind.UNION_TYPE_DEFINITION, Kind.DIRECTIVE_DEFINITION, Kind.FIELD_DEFINITION, Kind.INPUT_VALUE_DEFINITION, Kind.ENUM_VALUE_DEFINITION, Kind.OPERATION_DEFINITION];
declare type AllowedKind = typeof ALLOWED_KINDS[number];
export declare type RequireDescriptionRuleConfig = {
    types?: boolean;
} & {
    [key in AllowedKind]?: boolean;
};
declare const rule: GraphQLESLintRule<[RequireDescriptionRuleConfig]>;
export default rule;
