"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tTable_1 = require("./tTable");
const addToMean = (mean, n, newValue) => {
    return mean + (newValue - mean) / (n + 1);
};
const runningStats = () => {
    let n = 0;
    let sum = 0;
    let sumOfSquares = 0;
    let mean = 0;
    return (num) => {
        n++;
        mean = n === 1 ? num : addToMean(mean, n, num);
        sum += num;
        sumOfSquares += num ** 2;
        const standardDeviation = Math.sqrt(sumOfSquares / n - Math.pow(sum / n, 2));
        const standardErrorOfMean = standardDeviation / Math.sqrt(n);
        const critical = tTable_1.default[n - 1 || 1] || tTable_1.default[0];
        const marginOfError = standardErrorOfMean * critical;
        const relativeMarginOfError = (marginOfError / mean) * 100 || 0;
        return {
            n,
            mean,
            margin: relativeMarginOfError,
        };
    };
};
exports.default = runningStats;
