"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const isNode_1 = require("./isNode");
const runningStats_1 = require("../stats/runningStats");
const identity = (a) => a;
const noopNode = () => {
    const rs = (0, runningStats_1.default)();
    let stats = { n: 0, mean: 0, margin: Infinity };
    let n = 0;
    while (stats.margin > 0.1 || stats.n < 1e6) {
        const arg = Math.random();
        const t0 = process.hrtime.bigint();
        const result = identity(arg);
        const t1 = process.hrtime.bigint();
        stats = rs(Number(t1 - t0));
        n += result;
    }
    if (n <= 0) {
        throw 'Noop initializing error';
    }
    return {
        val: BigInt(Math.round(stats.mean)),
        boundary: stats.mean * (stats.margin / 100),
        margin: stats.margin,
    };
};
const noopBrowser = () => {
    const rs = (0, runningStats_1.default)();
    let stats = { n: 0, mean: 0, margin: Infinity };
    let n = 0;
    while (stats.margin > 1 || stats.n < 1e6) {
        const arg = Math.random();
        const t0 = performance.now();
        const result = identity(arg);
        const t1 = performance.now();
        stats = rs(t1 - t0);
        n += result;
    }
    if (n <= 0) {
        throw 'Noop initializing error';
    }
    return {
        val: stats.mean,
        boundary: stats.mean * (stats.margin / 100),
        margin: stats.margin,
    };
};
const noop = isNode_1.default ? noopNode() : noopBrowser();
exports.default = noop;
