"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _recommended = _interopRequireDefault(require("./configs/recommended.json"));

var _destructuringPropertyNewline = _interopRequireDefault(require("./rules/destructuringPropertyNewline"));

var _exportSpecifierNewline = _interopRequireDefault(require("./rules/exportSpecifierNewline"));

var _filenameMatchExported = _interopRequireDefault(require("./rules/filenameMatchExported"));

var _filenameMatchRegex = _interopRequireDefault(require("./rules/filenameMatchRegex"));

var _filenameNoIndex = _interopRequireDefault(require("./rules/filenameNoIndex"));

var _idMatch = _interopRequireDefault(require("./rules/idMatch"));

var _importSpecifierNewline = _interopRequireDefault(require("./rules/importSpecifierNewline"));

var _noRestrictedStrings = _interopRequireDefault(require("./rules/noRestrictedStrings"));

var _noUseExtendNative = _interopRequireDefault(require("./rules/noUseExtendNative"));

var _sortKeys = _interopRequireDefault(require("./rules/sortKeys"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _default = {
  configs: {
    recommended: _recommended.default
  },
  rules: {
    'destructuring-property-newline': _destructuringPropertyNewline.default,
    'export-specifier-newline': _exportSpecifierNewline.default,
    'filename-match-exported': _filenameMatchExported.default,
    'filename-match-regex': _filenameMatchRegex.default,
    'filename-no-index': _filenameNoIndex.default,
    'id-match': _idMatch.default,
    'import-specifier-newline': _importSpecifierNewline.default,
    'no-restricted-strings': _noRestrictedStrings.default,
    'no-use-extend-native': _noUseExtendNative.default,
    'sort-keys': _sortKeys.default
  },
  rulesConfig: {
    'destructuring-property-newline': 0,
    'export-specifier-newline': 0,
    'filename-match-exported': 0,
    'filename-match-regex': 0,
    'filename-no-index': 0,
    'id-match': 0,
    'import-specifier-newline': 0,
    'no-restricted-strings': 0,
    'no-use-extend-native': 0,
    'sort-keys': 0
  }
};
exports.default = _default;
module.exports = exports.default;