"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _path = _interopRequireDefault(require("path"));

var _isIgnoredFilename = require("../utilities/isIgnoredFilename");

var _isIndexFile = require("../utilities/isIndexFile");

var _parseFilename = require("../utilities/parseFilename");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @file Rule to ensure that there exist no index files
 * @author Stefan Lau
 */
const create = context => {
  return {
    Program(node) {
      const filename = context.getFilename();

      const absoluteFilename = _path.default.resolve(filename);

      const parsed = (0, _parseFilename.parseFilename)(absoluteFilename);
      const shouldIgnore = (0, _isIgnoredFilename.isIgnoredFilename)(filename);
      const isIndex = (0, _isIndexFile.isIndexFile)(parsed);

      if (shouldIgnore) {
        return;
      }

      if (isIndex) {
        context.report({
          message: '\'index.js\' files are not allowed.',
          node
        });
      }
    }

  };
};

var _default = {
  create,
  meta: {
    schema: [],
    type: 'suggestion'
  }
};
exports.default = _default;
module.exports = exports.default;