"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _fs = _interopRequireDefault(require("fs"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const fileAccessCache = {};

const isReadableFile = filePath => {
  // If the file was previously unreadable, we can assume this
  // will always be the case
  let accessable = fileAccessCache[filePath];

  if (accessable !== undefined) {
    return accessable;
  }

  try {
    _fs.default.accessSync(filePath, _fs.default.constants.R_OK);

    accessable = true;
  } catch (error) {
    accessable = false;
  }

  fileAccessCache[filePath] = accessable;
  return accessable;
};

var _default = isReadableFile;
exports.default = _default;
//# sourceMappingURL=isReadableFile.js.map